Imports System.Runtime.InteropServices

Public Class Form1

    'dichiarazione di api 
    <DllImport("coredll.dll")> _
    Private Shared Function BitBlt(ByVal hdcDest As IntPtr, ByVal nXDest As Integer, ByVal nYDest As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hdcSrc As IntPtr, _
    ByVal nXSrc As Integer, ByVal nYSrc As Integer, ByVal dwRop As Integer) As Boolean
    End Function

    <DllImport("coredll.dll")> _
    Public Shared Function GetDC(ByVal hWnd As System.IntPtr) As System.IntPtr
    End Function

    <DllImport("coredll.dll")> _
    Public Shared Function ReleaseDC(ByVal hWnd As System.IntPtr, ByVal hDC As System.IntPtr) As Integer
    End Function
    'cattura e salva l'immagine della sola form 
    Private Sub CatturaForm()
        'ottengo handler della form creo un oggetto di tipo bmp per gestire l'immagine 
        Dim srcDC As System.IntPtr = GetDC(Me.Handle)
        Dim bm As New System.Drawing.Bitmap(Me.Width, Me.Height)
        Dim graphics As System.Drawing.Graphics = System.Drawing.Graphics.FromImage(bm)
        Dim bmDC As System.IntPtr = graphics.GetHdc()
        'copio la form nella bitmap 
        BitBlt(bmDC, 0, 0, bm.Width, bm.Height, srcDC, _
        0, 0, 13369376)
        'Rilascio le risorse 
        ReleaseDC(Me.Handle, srcDC)
        graphics.ReleaseHdc(bmDC)
        graphics.Dispose()
        ' Salvo l'immagine in formato jpeg 
        Dim filename As String = "immagine.jpg"
        bm.Save(filename, System.Drawing.Imaging.ImageFormat.Jpeg)
        MessageBox.Show("Immagine salvata: " + filename)

    End Sub
    'cattura e salva l'immagine di tutta la finestra, compersa la taskbar 
    Private Sub CatturaFormConTaskBar()

        'ottengo handler della form creo un oggetto di tipo bmp per gestire l'immagine 
        Dim srcDC As System.IntPtr = GetDC(IntPtr.Zero)
        Dim bm As New System.Drawing.Bitmap(Me.Width, Me.Height)
        Dim graphics As System.Drawing.Graphics = System.Drawing.Graphics.FromImage(bm)
        Dim bmDC As System.IntPtr = graphics.GetHdc()
        'copio la form nella bitmap 
        BitBlt(bmDC, 0, 0, bm.Width, bm.Height, srcDC, _
        0, 0, 13369376)
        'Rilascio le risorse 
        ReleaseDC(IntPtr.Zero, srcDC)
        graphics.ReleaseHdc(bmDC)
        graphics.Dispose()

        ' Salvo l'immagine in formato jpeg 
        Dim filename As String = "immagine.jpg"
        ' String.Format("Snap{0}.jpg", index++); 
        bm.Save(filename, System.Drawing.Imaging.ImageFormat.Jpeg)
        MessageBox.Show("Immagine salvata: " + filename)
    End Sub

    Private Sub btnCattura_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCattura.Click
        CatturaForm()
    End Sub
    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        CatturaFormConTaskBar()
    End Sub
End Class
